\documentclass[conference]{IEEEtran}
\IEEEoverridecommandlockouts
% The preceding line is only needed to identify funding in the first footnote. If that is unneeded, please comment it out.
\usepackage{cite}
\usepackage{amsmath,amssymb,amsfonts}
% \usepackage{algorithmic}  % outcommend because of Algorithm 1
\usepackage{graphicx}
\usepackage{textcomp}
\usepackage{xcolor}
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
    T\kern-.1667em\lower.7ex\hbox{E}\kern-.125emX}}

% --- own packages ---
\usepackage{hyperref}
\hypersetup{
    colorlinks,
    citecolor=black,
    filecolor=black,
    linkcolor=black,
    urlcolor=black
}
\usepackage{algorithm}
\usepackage{algpseudocode}
% --- own packages ---

\begin{document}

\title{Generative Adversarial Networks Recap\\
{\footnotesize Seminar Neuroinspired Computation at RWTH-Aachen}

}

\author{\IEEEauthorblockN{1\textsuperscript{st} Lennart Fanter}
\IEEEauthorblockA{\textit{RWTH-Aachen} \\
% \textit{name of organization (of Aff.)}\\
Aachen, Germany \\
lennart.fanter@icloud.com}
% \and
% \IEEEauthorblockN{2\textsuperscript{nd} Given Name Surname}
% \IEEEauthorblockA{\textit{dept. name of organization (of Aff.)} \\
% \textit{name of organization (of Aff.)}\\
% City, Country \\
% email address or ORCID}
% \and
% \IEEEauthorblockN{3\textsuperscript{rd} Given Name Surname}
% \IEEEauthorblockA{\textit{dept. name of organization (of Aff.)} \\
% \textit{name of organization (of Aff.)}\\
% City, Country \\
% email address or ORCID}
% \and
% \IEEEauthorblockN{4\textsuperscript{th} Given Name Surname}
% \IEEEauthorblockA{\textit{dept. name of organization (of Aff.)} \\
% \textit{name of organization (of Aff.)}\\
% City, Country \\
% email address or ORCID}
% \and
% \IEEEauthorblockN{5\textsuperscript{th} Given Name Surname}
% \IEEEauthorblockA{\textit{dept. name of organization (of Aff.)} \\
% \textit{name of organization (of Aff.)}\\
% City, Country \\
% email address or ORCID}
% \and
% \IEEEauthorblockN{6\textsuperscript{th} Given Name Surname}
% \IEEEauthorblockA{\textit{dept. name of organization (of Aff.)} \\
% \textit{name of organization (of Aff.)}\\
% City, Country \\
% email address or ORCID}
}

\maketitle

\begin{abstract}
This paper provides a basic and precise overview about Generative Adversarial Networks (GANs). After which one should get the key ideas as well as the key math behind GANs abstract is work in progress.
\end{abstract}

\begin{IEEEkeywords}
component, formatting, style, styling, insert
\end{IEEEkeywords}

\section{Introduction}
 % - since the field of ML and Deep ML grows
 % - who invented: Ian Goodfellow
 % - goal: generate real looking data \\
In recent years, the landscape of machine learning has undergone unprecedented growth, fostering groundbreaking advancements in artificial intelligence. Within this transformative milieu, Generative Adversarial Networks (GANs) have emerged as a remarkable paradigm, being innovative and complex simultaneously. Introduced by Ian Goodfellow and his colleagues in 2014, GANs are designed for one main purpose: the generation of real looking data through an adversarial interplay of neural networks \cite{b1}.\\
They have achieved high success, fundamentally altering the landscape of machine learning. GANs have proven to be very successful in generating realistic data, transcending prior limitations in content creation. Their impact is evident across diverse domains, from image synthesis and style transfer to text-to-image translation. GANs have redefined the possibilities of artificial intelligence by enabling the generation of content indistinguishable from genuine data, thereby advancing applications in computer vision, data augmentation, and beyond.

\section{The Adversarial Framework}
 % - makes unsupervised supervised
 % - competing networks
% Within GANs there was also the adversarial framework introduced in 2014. The adversarial framework has the purpose to make the learning task able to use a supervised learning algorithm while being in an unsupervised environment meaning that there is just raw training data without any labeling. This is done by having a Generator which tries to generate real looking data to trick the Discriminator which has to decide whether this data is real or fake. In this context real data always refers to data which is from the training set while fake data is called in this way because it is generated by the Generator.\\
% \\
Within GANs there was also the adversarial framework introduced in 2014. This framework is strategically designed to facilitate the integration of a supervised learning algorithm within an unsupervised environment, characterized by the absence of labeled training data. The operational dynamics involve a Generator tasked with producing real-looking data, attempting to deceive the Discriminator who has to decide whether data or rather one sample is real or fake. Within this context, "real data" pertains to instances originating from the training set, while the term "fake data" is employed to describe generated data coming from the Generator.

\begin{figure}[htbp]
\centerline{\includegraphics[scale=0.08]{GANs.png}}
\caption{High-level overview about the adversarial framework and GANs. G being the Generator and D being the Discriminator. With half the time real and half the time fake data feeded into the Discriminator.}
\label{fig-GANs}
\end{figure}

\subsection{Goal}
 % - implicitly learn the probabily distribution -> not able to learn the exact distribution but being able to make samples of it
 % - explicit solution and maximum likelihood approaches
 % - being able to recreate real looking data
% The goal is to create a model which is capable of producing samples which could come from the original data set. Therefore in the past were solutions like maximum-likelihood approaches which try to learn the underlying probability distribution of the data set via parameterized models. By that they are able to produce samples from the revealed distribution. This type of approaches are called explicit generative models because they learn the underlying probability distribution. In contrast to that GANs belong to the field of implicit generative models because they are not able to reveal the underlying probability distribution but they are still capable of creating samples which could belong to the real data. Therefore one could create just much samples by the generator and by that get a approximation of the learned probability distribution.\\ 

The objective is to construct a model with the capability to generate samples indistinguishable from those within the original dataset. Historically, different approaches such as maximum-likelihood approaches have been employed to reveal and learn the underlying probability distribution of the dataset through parameterized models. This methodology enables the generation of samples from the established distribution. This type of approaches are called explicit generative models because they learn the underlying probability distribution. \\
In contrast, GANs operate within the domain of implicit generative models. Unlike explicit models, GANs do not explicitly reveal the underlying probability distribution. However, they are still able to excel in creating samples that closely resemble the original data. Consequently, GANs offer an alternative approach by generating an abundance of samples through the generator, providing an approximation of the acquired probability distribution.
\subsection{Generator}
 % - capture the data distribution and generate samples from that
 % - is a NN(most likely or rather at its origin MLP)
 % - input: noise / output: sample
The Generator (sometimes refered as G) has the goal of capturing the data distribution in order to generate samples which are real-looking and fooling the Discriminator. The Generator it self is a neural network or rather as in its origin an Multilayer Perceptron. Its input is a random noise vector $z$ which is most likely sampled from a gaussian distribution while the output should be an authentic-looking sample. Therefore, we can define the Generator as a function $G: n_N \rightarrow N$. With $n_N$ being the dimension of the random noise which is getting feeded in and $N$ being the dimension of one sample of the real training set.
\subsection{Discriminator}
 % - learn to decide whether a sample is fake or not (explaining what fake means)
 % - a NN
 % - sample from datat or G
 % - output: fake or not

 % schon sehr umgangssprachlich hier?
The Discriminator (also refered as D) has to learn to decide whether a sample is fake or not. It is also a neural network or Multilayer Perceptron but with more or less opposite input and output dimensions. The input is either a real or fake sample from the training set or the Generator. The desired output is a probability indicating the likelihood of the sample being genuine. Therefore, we can define the Discriminator as a function $D: N \rightarrow [0;1]$.
\subsection{GAN-Game}
 % - two player zero sum - advantage for one side = loss for the other \\
 % - value function: 
 % - minimax objective
 % - Solution/ end of the game: Nash equilibrium
% The GAN-Game comes from game theory and is a two player zero sum game. Meaning that an advantage for one side is equivalent to a loss for the opposite side. The value function V is as follows... . Theerefore, the minimax objective is ... . The solution of a game or rather the end is the Nash equilibrium where neither side can improve anymore.

The GAN game is derived from game theory, representing a two-player zero-sum game, where a gain for one participant corresponds to a loss for the other. Central to this formulation is the value function V, which is shown in \eqref{Value-Function}.
\begin{equation}
V(G,D) := \mathbb{E}_{x\sim \mathbb{P}_{data}}[lnD(x)] + \mathbb{E}_{z\sim \mathbb{P}_{noise}}[ln(1-D(G(z))] \label{Value-Function}
\end{equation}
Consequently, the minimax objective is shown in \eqref{minimax-objective}.
\begin{equation}
\min_G\max_D V(G,D) \label{minimax-objective}
\end{equation}
% The resolution of the game, signifying its conclusion, occurs at the Nash equilibrium, a state where neither participant can further enhance their position.
% When assigning a function $C(G) := \max_D V(G,D)$ it is likely to see that the global minimum occurs if and only if $\mathbb{P}_G=\mathbb{P}_{data}$. With $\mathbb{P}_G$ being the implicit distribution of the samples which are computed by the Generator. This is also very intuitive because if the Generator is so good that it is basically able to produce samples indistinguishable from the original data set, the Discriminator has a chance of $0.5$ guessing it right whether a sample is from the Generator or not.
The resolution of the game, signifying its conclusion, occurs at the Nash equilibrium, a state where neither participant can further enhance their position.\\
Upon defining a function $C(G) := \max_D V(G, D)$, it becomes likely to see that the global minimum is reached if and only if $\mathbb{P}_G = \mathbb{P}_{data}$. Here, $\mathbb{P}_G$ represents the implicit distribution of the samples computed by the Generator. This observation aligns intuitively with the notion that the Generator's proficiency is at its zenith when it can generate samples virtually indistinguishable from the original dataset. In such a scenario, the Discriminator faces a $50\%$ probability of correctly discerning whether a given sample is sourced from the Generator or the actual dataset. Besides, the optimal Discriminator is given by \eqref{Optimal-Discriminator}.
\begin{equation}
D(x)^*=\frac{\mathbb{P}_{data}(x)}{\mathbb{P}_{data}(x)+\mathbb{P}_{G}(x)} \label{Optimal-Discriminator}
\end{equation}
There one can easily see the intuitive thinking verified because if  $\mathbb{P}_G = \mathbb{P}_{data}$ applies then this also means $D(x)^*=\frac{1}{2}$.
\subsection{Training}
 % - Value function: again?
 % - Discriminator loss function
 % - G loss 
 % - Here you can also see why ln(1-D(G(z))) in the objective function got selected
 % -> therefore theoretical results -> when global min is reached + Jensen shannon Divergence
 % training steps

% for training with backpropagation labels are needed. so machen wir die... . dann loss functions. so machen wir die...
 
At training the great idea behind the adversarial framework appears. The Backpropagation algorithm is used to train both the Discriminator as well as the Generator. Since this is a supervised learning algorithm, there are labels and loss functions needed to proceed. The labels are produced by the adversarial framework itself. Meaning that one label of one sample is set to one if the data given to the Discriminator is from the training set and zero if the data is produced by the Generator. Next, the loss function one for each neural network. Since the Discriminator wants to maximize both terms of the objective function \eqref{minimax-objective} the loss function for the Discriminator is given by \eqref{Discriminator-Loss}.
\begin{equation}
L_D:=-V(G,D) \label{Discriminator-Loss}
\end{equation}
Here, it becomes obvious why it was decided to use $[ln(1-D(G(z))]$ in \eqref{Value-Function}. Such that the Discriminator aims to maximize both summands, not solely the first, while concurrently minimizing the second. The Generators loss function is determined by the value function \eqref{Value-Function} itself. But only the second part is influenced by the Generator. That is why the point, where the global minimum of the loss function of the Generator is, is equivalent to the minimum of only the second part of the value function. Hence, it is possible to simplify the loss function of the Generator to \eqref{Generator-Loss}.
\begin{equation}
 \underset{G}{\operatorname{argmin}}  V(G,D) = \underset{G}{\operatorname{argmin}}  \mathbb{E}_{z\sim \mathbb{P}_{noise}}[ln(1-D(G(z))] \label{Generator-Loss-Equivalents}
\end{equation}
\begin{equation}
L_G(G) = \mathbb{E}_{z\sim \mathbb{P}_{noise}}[ln(1-D(G(z))] \label{Generator-Loss}
\end{equation}
One huge advantage is that the backpropagation algorithm can backpropagate through the Discriminator to the Generator because they are both neural networks meaning that (unclear one question is about that)
%there are both multilinear functions? ne Warum kann man das da nochmal durchziehen?
One can imagine this of being one huge neural networks which directly connects the last layer of the Generator and the first layer of the Discriminator being able to backpropagate through the entire thing.\\
Now that the labels and loss functions are well-defined, the training process can commence. This process is essentially given by algorithm \ref{alg:training} introduced in the inaugural paper \cite{b1}.
\begin{algorithm}
\caption{Simplified GAN Training Algorithm}\label{alg:training}
\begin{algorithmic}
% \Require $n \geq 0$
% \Ensure $y = x^n$
\For{$number\ of\ training\ iterations$}
    \For{$k\ steps$}
        \State $z \gets sample\ from\ noise\ distribution$
        \State $\^x  \gets G(z)\ (generate\ fake\ samples) $
        \State $x \gets sample\ from\ data\ distribution$
        \State $update\ D$
    \EndFor
        \State $z \gets sample\ from\ noise\ distribution$
        \State $update\ G$
\EndFor
\end{algorithmic}
\end{algorithm}
The hyperparameter $k$ of Algorithm \ref{alg:training} is set to one at the original paper \cite{b1} meaning that the Discriminator and the Generator are updated the same amount of times. Its presence is justified by the fact that increasing the hyperparameter places greater focus on training the Discriminator. This heightened focus can lead to improved training outcomes for both the Discriminator and Generator. Notably, the training of the Generator hardly depends on the Discriminator's success. If the Discriminator categorizes all data as authentic, the Generator would gain minimal insights and would struggle to learn effectively.
% It is there because by increasing the hyperparameter one puts more focus on training the Discriminator which can result in better training results in both the Discriminator and Generator because the Generator training hardly depends on the success of the Discriminator. If the Discriminator determines every data to be real, the Generator would not learn anything.
\section{Challenges}
% - Lots of challenges faced
% - stability en general - not being stuck at training - for example Progressive Growing as solution \cite{b2}.
% - maybe different order
\subsection{Mode Collapse}
\subsection{Vanishing Gradients}
\subsection{Exploding Gradients}


\section{Variants}
% - lots of variations out there 
% -  Or certain domain like photos \cite{b3} DCGANs.
\subsection{Wasserstein GANs}
\cite{b4}


\section{Relation to other Learning Frameworks}
\subsection{Autoencoders}
\subsection{Reinforcement Learning}


\section{Relation to Neuroscience}


\section{Applications}
% lots of applications in the field of genertive models
\subsection{Conditional Generative Models}
\subsection{Latent Space arithmetic - Editing Faces}
% Fully diferential neural network send gradients through it
% Proof/PAper for the latent space arithmetic?
\subsection{Creating data for other ML algorithms}

\section{Conclusion}


\begin{thebibliography}{00}
% \bibitem{b1} G. Eason, B. Noble, and I. N. Sneddon, ``On certain integrals of Lipschitz-Hankel type involving products of Bessel functions,'' Phil. Trans. Roy. Soc. London, vol. A247, pp. 529--551, April 1955.
% \bibitem{b2} J. Clerk Maxwell, A Treatise on Electricity and Magnetism, 3rd ed., vol. 2. Oxford: Clarendon, 1892, pp.68--73.

\bibitem{b1} I. Goodfellow, J. Pouget-Abadie, M. Mirza, B. Xu, D. Warde-Farley, S. Ozair, A. Courville, and Y. Bengio, “Generative Adversarial Nets” in Advances in Neural Information Processing Systems 27, Z. Ghahramani, M. Welling, C. Cortes, N. D. Lawrence, and K. Q. Weinberger, Eds. Curran Associates, Inc., 2014, pp. 2672–2680. [Online]. Available: http://papers.nips.cc/paper/5423-generative-adversarial-nets.pdf

\bibitem{b2} Tero Karras, Timo Aila, Samuli Laine and Jaakko Lehtinen, “PROGRESSIVE GROWING OF GANS FOR IMPROVED QUALITY, STABILITY, AND VARIATION”. ICLR 2018. Available: https://research.nvidia.com/sites/default/files/pubs/2017-10\_Progressive-Growing-of/karras2018iclr-paper.pdf
% https://research.nvidia.com/sites/default/files/pubs/2017-10_Progressive-Growing-of/karras2018iclr-paper.pdf
% Nvdidia Paper showing that starting with al small resolution and growing from that ends in a more stable training process

\bibitem{b3} Alec Radford and Luke Metz, “UNSUPERVISED REPRESENTATION LEARNING WITH DEEP CONVOLUTIONAL
GENERATIVE ADVERSARIAL NETWORKS”. ICLR 2016. Available: ?
% DCGANs

\bibitem{b4} Martin Arjovsky, Soumith Chintala and L\'eon Bottou. “Wasserstein GAN”. 2017. Available: arXiv:1701.07875v3
% Wasserstein GAN

\bibitem{b5} Tero Karras, Samuli Laine and Timo Aila. “A Style-Based Generator Architecture for Generative Adversarial Networks”. 2019. Available: https://arxiv.org/abs/1812.04948
% Style GAN extens b2 and has the latent space calculation in it!!!

\bibitem{b6} David Pfau and Oriol Vinyals. “Connecting Generative Adversarial Networks and Actor-Critic Methods”. 2017. Available: https://arxiv.org/abs/1610.01945v3
% Actor critic and GANs

\bibitem{b7} Chelsea Finn, Paul Christiano, Pieter Abbeel and Sergey Levine. “A Connection Between Generative Adversarial Networks, Inverse Reinforcement Learning, and Energy-Based Models”. 2016. Available: https://arxiv.org/abs/1611.03852v3
% GANs and Inverse RL and Energy-Based Models

\end{thebibliography}


\end{document}
